"use strict";var arrayCount=function(arr,key){var count=0;for(var i=0;i<arr.length;i++){if(arr[i].name===key){count++}}return count};var arrayValue=function(arr,key){for(var i=0;i<arr.length;i++){if(arr[i].name===key){return arr[i].value}}return undefined};var assert=chai.assert;var fixture;describe("form",function(){before(function(){fixture=$("#main").html()});beforeEach(function(){$("#main").html(fixture)});it('"action" and "method" form attributes',function(){var f=$("#form1");assert.strictEqual(f.attr("action"),"ajax/text.html",'form "action"');assert.strictEqual(f.attr("method"),"get",'form "method"')});it("formToArray: multi-select",function(){var a=$("#form1").formToArray();assert.strictEqual(a.constructor,Array,"type check");assert.strictEqual(a.length,13,"array length");assert.strictEqual(arrayCount(a,"Multiple"),3,"multi-select")});it('formToArray: "action" and "method" inputs',function(){var a=$("#form1").formToArray();assert.strictEqual(a.constructor,Array,"type check");assert.strictEqual(arrayValue(a,"action"),"1","input name=action");assert.strictEqual(arrayValue(a,"method"),"2","input name=method")});it("formToArray: semantic test",function(){var formData=$("#form2").formToArray(true);var testData=["a","b","c","d","e","f"];for(var i=0;i<6;i++){assert.strictEqual(formData[i].name,testData[i],"match value at index="+i)}});it("formToArray: text promotion for missing value attributes",function(){var expected=[{name:"A",value:""},{name:"B",value:"MISSING_ATTR"},{name:"C",value:""},{name:"C",value:"MISSING_ATTR"}];var a=$("#form6").formToArray(true);for(var i=0;i<a.length;i++){assert.strictEqual(a[i].name,expected[i].name,"Name: "+a[i].name+" = "+expected[i].name);assert.strictEqual(a[i].value,expected[i].value,"Value: "+a[i].value+" = "+expected[i].value)}});it("formToArray: outside fields",function(){var formData=$("#form10").formToArray();assert.strictEqual(formData.length,2,'There are two "successful" elements of the form')});it("serialize: param count",function(){var s=$("#form1").formSerialize();assert.ok(s.constructor==String,"type check");assert.ok(s.split("&").length==13,"string array length")});it("serialize: pseudo form",function(){var s=$("#pseudo *").fieldSerialize();assert.ok(s.constructor==String,"type check");assert.ok(s.split("&").length==3,"string array length")});it("resetForm (text input)",function(){var $el=$("#form1 input[name=Name]");var val=$el.val();assert.ok("MyName1"==val,"beforeSubmit: "+val);$el.val("test");val=$el.val();assert.ok("test"==$el.val(),"update: "+val);$("#form1").resetForm();val=$el.val();assert.ok("MyName1"==val,"success: "+val)});it("resetForm (select)",function(){var $el=$("#form1 select[name=Single]");var val=$el.val();assert.ok("one"==val,"beforeSubmit: "+val);$el.val("two");val=$el.val();assert.ok("two"==$el.val(),"update: "+val);$("#form1").resetForm();val=$el.val();assert.ok("one"==val,"success: "+val)});it("resetForm (textarea)",function(){var $el=$("#form1 textarea");var val=$el.val();assert.ok("This is Form1"==val,"beforeSubmit: "+val);$el.val("test");val=$el.val();assert.ok("test"==val,"udpate: "+val);$("#form1").resetForm();val=$el.val();assert.ok("This is Form1"==val,"success: "+val)});it("resetForm (checkbox)",function(){var el=$("#form1 input:checkbox:checked")[0];var val=el.value;assert.ok(el.checked,"beforeSubmit: "+el.checked);el.checked=false;assert.ok(!el.checked,"update: "+el.checked);$("#form1").resetForm();assert.ok(el.checked,"success: "+el.checked)});it("resetForm (radio)",function(){var el=$("#form1 input:radio:checked")[0];var val=el.value;assert.ok(el.checked,"beforeSubmit: "+el.checked);el.checked=false;assert.ok(!el.checked,"update: "+el.checked);$("#form1").resetForm();assert.ok(el.checked,"success: "+el.checked)});it("clearForm (text input)",function(){var $el=$("#form1 input[name=Name]");var val=$el.val();assert.ok("MyName1"==val,"beforeSubmit: "+val);$("#form1").clearForm();val=$el.val();assert.ok(""==val,"success: "+val)});it("clearForm (select)",function(){var $el=$("#form1 select[name=Single]");var val=$el.val();assert.ok("one"==val,"beforeSubmit: "+val);$("#form1").clearForm();val=$el.val();assert.ok(!val,"success: "+val)});it("clearForm: (hidden input)",function(){var $el=$("#form1 input:hidden");var val=$el.val();assert.ok("hiddenValue"==val,"beforeSubmit: "+val);$("#form1").clearForm();val=$el.val();assert.ok("hiddenValue"==val,"success: "+val)});it("clearForm: (submit input)",function(){var $el=$("#form1 input:submit");var val=$el.val();assert.ok("Submit1"==val,"beforeSubmit: "+val);$("#form1").clearForm();val=$el.val();assert.ok("Submit1"==val,"success: "+val)});it("clearForm (checkbox)",function(){var el=$("#form1 input:checkbox:checked")[0];assert.ok(el.checked,"beforeSubmit: "+el.checked);$("#form1").clearForm();assert.ok(!el.checked,"success: "+el.checked)});it("clearForm (radio)",function(){var el=$("#form1 input:radio:checked")[0];assert.ok(el.checked,"beforeSubmit: "+el.checked);$("#form1").clearForm();assert.ok(!el.checked,"success: "+el.checked)});it("ajaxSubmit: target == String",function(){$("#targetDiv").empty();var opts={target:"#targetDiv",success:function(){assert.ok(true,"post-callback");assert.ok($("#targetDiv").text().match("Lorem ipsum"),"targetDiv updated")}};$("#form3").ajaxSubmit(opts)});it("ajaxSubmit: target == jQuery object",function(){var target=$("#targetDiv");target.empty();var opts={target:target,success:function(responseText){assert.ok(true,"post-callback");assert.ok($("#targetDiv").text().match("Lorem ipsum"),"targetDiv updated")}};$("#form2").ajaxSubmit(opts)});it("ajaxSubmit: target == DOM element",function(){$("#targetDiv").empty();var el=$("#targetDiv")[0];var opts={target:"#targetDiv",success:function(responseText){assert.ok(true,"post-callback");assert.ok($("#targetDiv").text().match("Lorem ipsum"),"targetDiv updated")}};$("#form2").ajaxSubmit(opts)});it("ajaxSubmit: load target with scripts",function(){$("#targetDiv").empty();var opts={target:"#targetDiv",url:"ajax/doc-with-scripts.html?"+(new Date).getTime(),success:function(responseText){assert.ok(true,"success-callback");assert.ok($("#targetDiv").text().match("Lorem ipsum"),"targetDiv updated");assert.ok(typeof unitTestVariable1!="undefined","first script block executed");assert.ok(typeof unitTestVariable2!="undefined","second script block executed");assert.ok(typeof scriptCount!="undefined","third script block executed");assert.ok(scriptCount==1,"scripts executed once: "+scriptCount)}};$("#form2").ajaxSubmit(opts)});it("ajaxSubmit: pre-submit callback",function(){var opts={beforeSubmit:function(a,jq){assert.ok(true,"pre-submit callback");assert.ok(a.constructor==Array,"type check array");assert.ok(jq.jquery,"type check jQuery");assert.ok(jq[0].tagName.toLowerCase()=="form",'jQuery arg == "form": '+jq[0].tagName.toLowerCase())}};$("#form3").ajaxSubmit(opts)});it("ajaxSubmit: post-submit callback",function(){var opts={success:function(responseText,statusText){assert.ok(true,"post-submit callback");assert.ok(responseText.match("Lorem ipsum"),"responseText");assert.ok(statusText=="success","statusText")}};$("#form3").ajaxSubmit(opts)});it("ajaxSubmit: function arg",function(){$("#form3").ajaxSubmit(function(){assert.ok(true,"callback hit")})});it("ajaxSubmit: semantic test",function(){var testData=["a","b","c","d","e","f"];var opts={semantic:true,beforeSubmit:function(a,jq){assert.ok(true,"pre-submit callback");assert.ok(a.constructor==Array,"type check");assert.ok(jq.jquery,"type check jQuery");for(var i=0;i<a.length;i++){assert.ok(a[i].name==testData[i],"match value at index="+i)}}};$("#form2").ajaxSubmit(opts)});it("ajaxSubmit: dataType == json",function(){var opts={url:"ajax/json.json",dataType:"json",success:function(data,statusText){assert.ok(typeof data=="object","json data type");assert.ok(data.name=="jquery-test","json data contents")}};$("#form2").ajaxSubmit(opts)});it("ajaxSubmit: dataType == script",function(){var opts={url:"ajax/script.txt?"+(new Date).getTime(),dataType:"script",success:function(responseText,statusText){assert.ok(typeof formScriptTest=="function","script evaluated");assert.ok(responseText.match("formScriptTest"),"script returned")}};$("#form2").ajaxSubmit(opts)});it("ajaxSubmit: dataType == xml",function(){var opts={url:"ajax/test.xml",dataType:"xml",success:function(responseXML,statusText){assert.ok(typeof responseXML=="object","data type xml");assert.ok($("test",responseXML).size()==3,"xml data query")}};$("#form2").ajaxSubmit(opts)});it("ajaxSubmit: existing args in action attr",function(){var opts={success:function(){assert.ok(true,"post callback")}};$("#form5").ajaxSubmit(opts)});it("ajaxSubmit: cancel submit",function(){var opts={beforeSubmit:function(a,jq){assert.ok(true,"pre-submit callback");assert.ok(a.constructor==Array,"type check");assert.ok(jq.jquery,"type check jQuery");return false},success:function(){assert.ok(false,"should not hit this post-submit callback")}};$("#form3").ajaxSubmit(opts)});it("ajaxSubmit: pseudo-form",function(){var opts={beforeSubmit:function(a,jq){assert.ok(true,"pre-submit callback");assert.ok(a.constructor==Array,"type check");assert.ok(jq.jquery,"type check jQuery");assert.ok(jq[0].tagName.toLowerCase()=="div",'jQuery arg == "div"')},success:function(){assert.ok(true,"post-submit callback")},url:"ajax/text.html",type:"post"};$("#pseudo").ajaxSubmit(opts)});it("ajaxSubmit: evaluate response",function(){var opts={success:function(responseText){assert.ok(true,"post-callback");var data=eval.call(window,"("+responseText+")");assert.ok(data.name=="jquery-test","evaled response")},url:"ajax/json.txt"};$("#form2").ajaxSubmit(opts)});it("ajaxForm: pre and post callbacks",function(){var opts={beforeSubmit:function(a,jq){assert.ok(true,"pre-submit callback");assert.ok(a.constructor==Array,"type check");assert.ok(jq.jquery,"type check jQuery")},success:function(){assert.ok(true,"post-submit callback")}};$("#form4").ajaxForm(opts);$("#submitForm4")[0].click()});it("ajaxForm: capture submit element",function(){var opts={beforeSubmit:function(a,jq){assert.ok(true,"pre-callback");assert.ok(a.constructor==Array,"type check");assert.ok(jq.jquery,"type check jQuery");assert.ok(arrayValue(a,"form4inputName")!==null,"submit button")}};$("#form4").ajaxForm(opts);$("#submitForm4withName")[0].click()});it("ajaxForm: capture submit image coordinates",function(){var opts={beforeSubmit:function(a,jq){assert.ok(true,"pre-callback");assert.ok(a.constructor==Array,"type check");assert.ok(jq.jquery,"type check jQuery");assert.ok(arrayValue(a,"myImage.x")!==null,"x coord");assert.ok(arrayValue(a,"myImage.y")!==null,"y coord")}};$("#form4").ajaxForm(opts);$("#form4imageSubmit")[0].click()});it("ajaxForm: capture submit image coordinates (semantic=true)",function(){var opts={semantic:true,beforeSubmit:function(a,jq){assert.ok(true,"pre-callback");assert.ok(a.constructor==Array,"type check");assert.ok(jq.jquery,"type check jQuery");assert.ok(arrayValue(a,"myImage.x")!==null,"x coord");assert.ok(arrayValue(a,"myImage.y")!==null,"y coord")}};$("#form4").ajaxForm(opts);$("#form4imageSubmit")[0].click()});it("ajaxForm: update target div",function(){$("#targetDiv").empty();var opts={target:"#targetDiv",beforeSubmit:function(a,jq){assert.ok(true,"pre-callback");assert.ok(a.constructor==Array,"type check");assert.ok(jq.jquery,"type check jQuery")},success:function(){assert.ok(true,"post-callback");assert.ok($("#targetDiv").text().match("Lorem ipsum"),"targetDiv updated")}};$("#form4").ajaxForm(opts);$("#submitForm4")[0].click()});it('"success" callback',function(){$("#targetDiv").empty();var opts={success:function(){assert.ok(true,"post-callback")}};$("#form3").ajaxSubmit(opts)});it('"error" callback',function(){$("#targetDiv").empty();var opts={url:"ajax/404.html",error:function(){assert.ok(true,"error-callback")},success:function(){assert.ok(false,"should not hit post-submit callback")}};$("#form3").ajaxSubmit(opts)});it("fieldValue(true)",function(){var i;assert.ok("5"==$("#fieldTest input").fieldValue(true)[0],"input");assert.ok("1"==$("#fieldTest :input").fieldValue(true)[0],":input");assert.ok("5"==$("#fieldTest input:hidden").fieldValue(true)[0],":hidden");assert.ok("14"==$("#fieldTest :password").fieldValue(true)[0],":password");assert.ok("12"==$("#fieldTest :radio").fieldValue(true)[0],":radio");assert.ok("1"==$("#fieldTest select").fieldValue(true)[0],"select");var expected=["8","10"];var result=$("#fieldTest :checkbox").fieldValue(true);assert.ok(result.length==expected.length,"result size check (checkbox): "+result.length+"="+expected.length);for(i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i])}expected=["3","4"];result=$("#fieldTest [name=B]").fieldValue(true);assert.ok(result.length==expected.length,"result size check (select-multiple): "+result.length+"="+expected.length);for(i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i])}});it("fieldValue(false)",function(){var i;assert.ok("5"==$("#fieldTest input").fieldValue(false)[0],"input");assert.ok("1"==$("#fieldTest :input").fieldValue(false)[0],":input");assert.ok("5"==$("#fieldTest input:hidden").fieldValue(false)[0],":hidden");assert.ok("14"==$("#fieldTest :password").fieldValue(false)[0],":password");assert.ok("1"==$("#fieldTest select").fieldValue(false)[0],"select");var expected=["8","9","10"];var result=$("#fieldTest :checkbox").fieldValue(false);assert.ok(result.length==expected.length,"result size check (checkbox): "+result.length+"="+expected.length);for(i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i])}expected=["11","12","13"];result=$("#fieldTest :radio").fieldValue(false);assert.ok(result.length==expected.length,"result size check (radio): "+result.length+"="+expected.length);for(i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i])}expected=["3","4"];result=$("#fieldTest [name=B]").fieldValue(false);assert.ok(result.length==expected.length,"result size check (select-multiple): "+result.length+"="+expected.length);for(i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i])}});it("fieldSerialize(true) input",function(){var expected=["C=5","D=6","F=8","F=10","G=12","H=14"];var result=$("#fieldTest input").fieldSerialize(true);result=result.split("&");assert.ok(result.length==expected.length,"result size check: "+result.length+"="+expected.length);for(var i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i]+" = "+result[i])}});it("fieldSerialize(true) :input",function(){var expected=["A=1","B=3","B=4","C=5","D=6","E=7","F=8","F=10","G=12","H=14"];var result=$("#fieldTest :input").fieldSerialize(true);result=result.split("&");assert.ok(result.length==expected.length,"result size check: "+result.length+"="+expected.length);for(var i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i]+" = "+result[i])}});it("fieldSerialize(false) :input",function(){var expected=["A=1","B=3","B=4","C=5","D=6","E=7","F=8","F=9","F=10","G=11","G=12","G=13","H=14","I=15","J=16"];var result=$("#fieldTest :input").fieldSerialize(false);result=result.split("&");assert.ok(result.length==expected.length,"result size check: "+result.length+"="+expected.length);for(var i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i]+" = "+result[i])}});it("fieldSerialize(true) select-mulitple",function(){var expected=["B=3","B=4"];var result=$("#fieldTest [name=B]").fieldSerialize(true);result=result.split("&");assert.ok(result.length==expected.length,"result size check: "+result.length+"="+expected.length);for(var i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i]+" = "+result[i])}});it("fieldSerialize(true) :checkbox",function(){var expected=["F=8","F=10"];var result=$("#fieldTest :checkbox").fieldSerialize(true);result=result.split("&");assert.ok(result.length==expected.length,"result size check: "+result.length+"="+expected.length);for(var i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i]+" = "+result[i])}});it("fieldSerialize(false) :checkbox",function(){var expected=["F=8","F=9","F=10"];var result=$("#fieldTest :checkbox").fieldSerialize(false);result=result.split("&");assert.ok(result.length==expected.length,"result size check: "+result.length+"="+expected.length);for(var i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i]+" = "+result[i])}});it("fieldSerialize(true) :radio",function(){var expected=["G=12"];var result=$("#fieldTest :radio").fieldSerialize(true);result=result.split("&");assert.ok(result.length==expected.length,"result size check: "+result.length+"="+expected.length);for(var i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i]+" = "+result[i])}});it("fieldSerialize(false) :radio",function(){var expected=["G=11","G=12","G=13"];var result=$("#fieldTest :radio").fieldSerialize(false);result=result.split("&");assert.ok(result.length==expected.length,"result size check: "+result.length+"="+expected.length);for(var i=0;i<result.length;i++){assert.ok(result[i]==expected[i],expected[i]+" = "+result[i])}});it("ajaxForm - auto unbind",function(){$("#targetDiv").empty();var opts={target:"#targetDiv",beforeSubmit:function(a,jq){assert.ok(true,"pre-callback")},success:function(){assert.ok(true,"post-callback")}};$("#form8").ajaxForm(opts).ajaxForm(opts).ajaxForm(opts);$("#submitForm8")[0].click()});it("ajaxFormUnbind",function(){$("#targetDiv").empty();var opts={target:"#targetDiv",beforeSubmit:function(a,jq){assert.ok(true,"pre-callback")},success:function(){assert.ok(true,"post-callback")}};$("#form9").ajaxForm(opts).submit(function(){return false});$("#form9").ajaxFormUnbind(opts);$("#submitForm9")[0].click()});it("naked hash",function(){$("#actionTest1").ajaxSubmit({beforeSerialize:function($f,opts){assert.ok(true,"url="+opts.url)}});assert.ok(true,"ajaxSubmit passed")});it("hash only",function(){$("#actionTest2").ajaxSubmit({beforeSerialize:function($f,opts){assert.ok(true,"url="+opts.url)}});assert.ok(true,"ajaxSubmit passed")});it("empty action",function(){$("#actionTest3").ajaxSubmit({beforeSerialize:function($f,opts){assert.ok(true,"url="+opts.url)}});assert.ok(true,"ajaxSubmit passed")});it("missing action",function(){$("#actionTest4").ajaxSubmit({beforeSerialize:function($f,opts){assert.ok(true,"url="+opts.url)}});assert.ok(true,"ajaxSubmit passed")});it("success callback params",function(){var $testForm;$("#targetDiv").empty();if(/^1\.3/.test($.fn.jquery)){$testForm=$("#form3").ajaxSubmit({success:function(data,status,$form){assert.ok(true,"success callback invoked");assert.ok(status==="success","status === success");assert.ok($form===$testForm,"$form param is valid")}})}else{$testForm=$("#form3").ajaxSubmit({success:function(data,status,xhr,$form){assert.ok(true,"success callback invoked");assert.ok(status==="success","status === success");assert.ok(true,"third arg: "+typeof xhr!=undefined);assert.ok(!!xhr!=false,"xhr != false");assert.ok(xhr.status,"xhr.status == "+xhr.status);assert.ok($form===$testForm,"$form param is valid")}})}});it("forceSync",function(){$("#targetDiv").empty();var $testForm=$("#form3").ajaxSubmit({forceSync:true,success:function(data,status,$form){assert.ok(true,"success callback invoked");assert.ok(status==="success","status === success")}})})});