"use strict";var defaults=require("./core.defaults");var helpers=require("../helpers/index");var Interaction=require("./core.interaction");var platform=require("../platforms/platform");module.exports=function(Chart){var plugins=Chart.plugins;Chart.types={};Chart.instances={};Chart.controllers={};function initConfig(config){config=config||{};var data=config.data=config.data||{};data.datasets=data.datasets||[];data.labels=data.labels||[];config.options=helpers.configMerge(defaults.global,defaults[config.type],config.options||{});return config}function updateConfig(chart){var newOptions=chart.options;if(newOptions.scale){chart.scale.options=newOptions.scale}else if(newOptions.scales){newOptions.scales.xAxes.concat(newOptions.scales.yAxes).forEach(function(scaleOptions){chart.scales[scaleOptions.id].options=scaleOptions})}chart.tooltip._options=newOptions.tooltips}function positionIsHorizontal(position){return position==="top"||position==="bottom"}helpers.extend(Chart.prototype,{construct:function(item,config){var me=this;config=initConfig(config);var context=platform.acquireContext(item,config);var canvas=context&&context.canvas;var height=canvas&&canvas.height;var width=canvas&&canvas.width;me.id=helpers.uid();me.ctx=context;me.canvas=canvas;me.config=config;me.width=width;me.height=height;me.aspectRatio=height?width/height:null;me.options=config.options;me._bufferedRender=false;me.chart=me;me.controller=me;Chart.instances[me.id]=me;Object.defineProperty(me,"data",{get:function(){return me.config.data},set:function(value){me.config.data=value}});if(!context||!canvas){console.error("Failed to create chart: can't acquire context from the given item");return}me.initialize();me.update()},initialize:function(){var me=this;plugins.notify(me,"beforeInit");helpers.retinaScale(me,me.options.devicePixelRatio);me.bindEvents();if(me.options.responsive){me.resize(true)}me.ensureScalesHaveIDs();me.buildScales();me.initToolTip();plugins.notify(me,"afterInit");return me},clear:function(){helpers.canvas.clear(this);return this},stop:function(){Chart.animationService.cancelAnimation(this);return this},resize:function(silent){var me=this;var options=me.options;var canvas=me.canvas;var aspectRatio=options.maintainAspectRatio&&me.aspectRatio||null;var newWidth=Math.max(0,Math.floor(helpers.getMaximumWidth(canvas)));var newHeight=Math.max(0,Math.floor(aspectRatio?newWidth/aspectRatio:helpers.getMaximumHeight(canvas)));if(me.width===newWidth&&me.height===newHeight){return}canvas.width=me.width=newWidth;canvas.height=me.height=newHeight;canvas.style.width=newWidth+"px";canvas.style.height=newHeight+"px";helpers.retinaScale(me,options.devicePixelRatio);if(!silent){var newSize={width:newWidth,height:newHeight};plugins.notify(me,"resize",[newSize]);if(me.options.onResize){me.options.onResize(me,newSize)}me.stop();me.update(me.options.responsiveAnimationDuration)}},ensureScalesHaveIDs:function(){var options=this.options;var scalesOptions=options.scales||{};var scaleOptions=options.scale;helpers.each(scalesOptions.xAxes,function(xAxisOptions,index){xAxisOptions.id=xAxisOptions.id||"x-axis-"+index});helpers.each(scalesOptions.yAxes,function(yAxisOptions,index){yAxisOptions.id=yAxisOptions.id||"y-axis-"+index});if(scaleOptions){scaleOptions.id=scaleOptions.id||"scale"}},buildScales:function(){var me=this;var options=me.options;var scales=me.scales={};var items=[];if(options.scales){items=items.concat((options.scales.xAxes||[]).map(function(xAxisOptions){return{options:xAxisOptions,dtype:"category",dposition:"bottom"}}),(options.scales.yAxes||[]).map(function(yAxisOptions){return{options:yAxisOptions,dtype:"linear",dposition:"left"}}))}if(options.scale){items.push({options:options.scale,dtype:"radialLinear",isDefault:true,dposition:"chartArea"})}helpers.each(items,function(item){var scaleOptions=item.options;var scaleType=helpers.valueOrDefault(scaleOptions.type,item.dtype);var scaleClass=Chart.scaleService.getScaleConstructor(scaleType);if(!scaleClass){return}if(positionIsHorizontal(scaleOptions.position)!==positionIsHorizontal(item.dposition)){scaleOptions.position=item.dposition}var scale=new scaleClass({id:scaleOptions.id,options:scaleOptions,ctx:me.ctx,chart:me});scales[scale.id]=scale;scale.mergeTicksOptions();if(item.isDefault){me.scale=scale}});Chart.scaleService.addScalesToLayout(this)},buildOrUpdateControllers:function(){var me=this;var types=[];var newControllers=[];helpers.each(me.data.datasets,function(dataset,datasetIndex){var meta=me.getDatasetMeta(datasetIndex);var type=dataset.type||me.config.type;if(meta.type&&meta.type!==type){me.destroyDatasetMeta(datasetIndex);meta=me.getDatasetMeta(datasetIndex)}meta.type=type;types.push(meta.type);if(meta.controller){meta.controller.updateIndex(datasetIndex)}else{var ControllerClass=Chart.controllers[meta.type];if(ControllerClass===undefined){throw new Error('"'+meta.type+'" is not a chart type.')}meta.controller=new ControllerClass(me,datasetIndex);newControllers.push(meta.controller)}},me);return newControllers},resetElements:function(){var me=this;helpers.each(me.data.datasets,function(dataset,datasetIndex){me.getDatasetMeta(datasetIndex).controller.reset()},me)},reset:function(){this.resetElements();this.tooltip.initialize()},update:function(config){var me=this;if(!config||typeof config!=="object"){config={duration:config,lazy:arguments[1]}}updateConfig(me);if(plugins.notify(me,"beforeUpdate")===false){return}me.tooltip._data=me.data;var newControllers=me.buildOrUpdateControllers();helpers.each(me.data.datasets,function(dataset,datasetIndex){me.getDatasetMeta(datasetIndex).controller.buildOrUpdateElements()},me);me.updateLayout();helpers.each(newControllers,function(controller){controller.reset()});me.updateDatasets();plugins.notify(me,"afterUpdate");if(me._bufferedRender){me._bufferedRequest={duration:config.duration,easing:config.easing,lazy:config.lazy}}else{me.render(config)}},updateLayout:function(){var me=this;if(plugins.notify(me,"beforeLayout")===false){return}Chart.layoutService.update(this,this.width,this.height);plugins.notify(me,"afterScaleUpdate");plugins.notify(me,"afterLayout")},updateDatasets:function(){var me=this;if(plugins.notify(me,"beforeDatasetsUpdate")===false){return}for(var i=0,ilen=me.data.datasets.length;i<ilen;++i){me.updateDataset(i)}plugins.notify(me,"afterDatasetsUpdate")},updateDataset:function(index){var me=this;var meta=me.getDatasetMeta(index);var args={meta:meta,index:index};if(plugins.notify(me,"beforeDatasetUpdate",[args])===false){return}meta.controller.update();plugins.notify(me,"afterDatasetUpdate",[args])},render:function(config){var me=this;if(!config||typeof config!=="object"){config={duration:config,lazy:arguments[1]}}var duration=config.duration;var lazy=config.lazy;if(plugins.notify(me,"beforeRender")===false){return}var animationOptions=me.options.animation;var onComplete=function(animation){plugins.notify(me,"afterRender");helpers.callback(animationOptions&&animationOptions.onComplete,[animation],me)};if(animationOptions&&(typeof duration!=="undefined"&&duration!==0||typeof duration==="undefined"&&animationOptions.duration!==0)){var animation=new Chart.Animation({numSteps:(duration||animationOptions.duration)/16.66,easing:config.easing||animationOptions.easing,render:function(chart,animationObject){var easingFunction=helpers.easing.effects[animationObject.easing];var currentStep=animationObject.currentStep;var stepDecimal=currentStep/animationObject.numSteps;chart.draw(easingFunction(stepDecimal),stepDecimal,currentStep)},onAnimationProgress:animationOptions.onProgress,onAnimationComplete:onComplete});Chart.animationService.addAnimation(me,animation,duration,lazy)}else{me.draw();onComplete(new Chart.Animation({numSteps:0,chart:me}))}return me},draw:function(easingValue){var me=this;me.clear();if(helpers.isNullOrUndef(easingValue)){easingValue=1}me.transition(easingValue);if(plugins.notify(me,"beforeDraw",[easingValue])===false){return}helpers.each(me.boxes,function(box){box.draw(me.chartArea)},me);if(me.scale){me.scale.draw()}me.drawDatasets(easingValue);me.tooltip.draw();plugins.notify(me,"afterDraw",[easingValue])},transition:function(easingValue){var me=this;for(var i=0,ilen=(me.data.datasets||[]).length;i<ilen;++i){if(me.isDatasetVisible(i)){me.getDatasetMeta(i).controller.transition(easingValue)}}me.tooltip.transition(easingValue)},drawDatasets:function(easingValue){var me=this;if(plugins.notify(me,"beforeDatasetsDraw",[easingValue])===false){return}for(var i=(me.data.datasets||[]).length-1;i>=0;--i){if(me.isDatasetVisible(i)){me.drawDataset(i,easingValue)}}plugins.notify(me,"afterDatasetsDraw",[easingValue])},drawDataset:function(index,easingValue){var me=this;var meta=me.getDatasetMeta(index);var args={meta:meta,index:index,easingValue:easingValue};if(plugins.notify(me,"beforeDatasetDraw",[args])===false){return}meta.controller.draw(easingValue);plugins.notify(me,"afterDatasetDraw",[args])},getElementAtEvent:function(e){return Interaction.modes.single(this,e)},getElementsAtEvent:function(e){return Interaction.modes.label(this,e,{intersect:true})},getElementsAtXAxis:function(e){return Interaction.modes["x-axis"](this,e,{intersect:true})},getElementsAtEventForMode:function(e,mode,options){var method=Interaction.modes[mode];if(typeof method==="function"){return method(this,e,options)}return[]},getDatasetAtEvent:function(e){return Interaction.modes.dataset(this,e,{intersect:true})},getDatasetMeta:function(datasetIndex){var me=this;var dataset=me.data.datasets[datasetIndex];if(!dataset._meta){dataset._meta={}}var meta=dataset._meta[me.id];if(!meta){meta=dataset._meta[me.id]={type:null,data:[],dataset:null,controller:null,hidden:null,xAxisID:null,yAxisID:null}}return meta},getVisibleDatasetCount:function(){var count=0;for(var i=0,ilen=this.data.datasets.length;i<ilen;++i){if(this.isDatasetVisible(i)){count++}}return count},isDatasetVisible:function(datasetIndex){var meta=this.getDatasetMeta(datasetIndex);return typeof meta.hidden==="boolean"?!meta.hidden:!this.data.datasets[datasetIndex].hidden},generateLegend:function(){return this.options.legendCallback(this)},destroyDatasetMeta:function(datasetIndex){var id=this.id;var dataset=this.data.datasets[datasetIndex];var meta=dataset._meta&&dataset._meta[id];if(meta){meta.controller.destroy();delete dataset._meta[id]}},destroy:function(){var me=this;var canvas=me.canvas;var i,ilen;me.stop();for(i=0,ilen=me.data.datasets.length;i<ilen;++i){me.destroyDatasetMeta(i)}if(canvas){me.unbindEvents();helpers.canvas.clear(me);platform.releaseContext(me.ctx);me.canvas=null;me.ctx=null}plugins.notify(me,"destroy");delete Chart.instances[me.id]},toBase64Image:function(){return this.canvas.toDataURL.apply(this.canvas,arguments)},initToolTip:function(){var me=this;me.tooltip=new Chart.Tooltip({_chart:me,_chartInstance:me,_data:me.data,_options:me.options.tooltips},me)},bindEvents:function(){var me=this;var listeners=me._listeners={};var listener=function(){me.eventHandler.apply(me,arguments)};helpers.each(me.options.events,function(type){platform.addEventListener(me,type,listener);listeners[type]=listener});if(me.options.responsive){listener=function(){me.resize()};platform.addEventListener(me,"resize",listener);listeners.resize=listener}},unbindEvents:function(){var me=this;var listeners=me._listeners;if(!listeners){return}delete me._listeners;helpers.each(listeners,function(listener,type){platform.removeEventListener(me,type,listener)})},updateHoverStyle:function(elements,mode,enabled){var method=enabled?"setHoverStyle":"removeHoverStyle";var element,i,ilen;for(i=0,ilen=elements.length;i<ilen;++i){element=elements[i];if(element){this.getDatasetMeta(element._datasetIndex).controller[method](element)}}},eventHandler:function(e){var me=this;var tooltip=me.tooltip;if(plugins.notify(me,"beforeEvent",[e])===false){return}me._bufferedRender=true;me._bufferedRequest=null;var changed=me.handleEvent(e);changed|=tooltip&&tooltip.handleEvent(e);plugins.notify(me,"afterEvent",[e]);var bufferedRequest=me._bufferedRequest;if(bufferedRequest){me.render(bufferedRequest)}else if(changed&&!me.animating){me.stop();me.render(me.options.hover.animationDuration,true)}me._bufferedRender=false;me._bufferedRequest=null;return me},handleEvent:function(e){var me=this;var options=me.options||{};var hoverOptions=options.hover;var changed=false;me.lastActive=me.lastActive||[];if(e.type==="mouseout"){me.active=[]}else{me.active=me.getElementsAtEventForMode(e,hoverOptions.mode,hoverOptions)}helpers.callback(options.onHover||options.hover.onHover,[e.native,me.active],me);if(e.type==="mouseup"||e.type==="click"){if(options.onClick){options.onClick.call(me,e.native,me.active)}}if(me.lastActive.length){me.updateHoverStyle(me.lastActive,hoverOptions.mode,false)}if(me.active.length&&hoverOptions.mode){me.updateHoverStyle(me.active,hoverOptions.mode,true)}changed=!helpers.arrayEquals(me.active,me.lastActive);me.lastActive=me.active;return changed}});Chart.Controller=Chart};