"use strict";var moment=require("moment");moment=typeof moment==="function"?moment:window.moment;var defaults=require("../core/core.defaults");var helpers=require("../helpers/index");var MIN_INTEGER=Number.MIN_SAFE_INTEGER||-9007199254740991;var MAX_INTEGER=Number.MAX_SAFE_INTEGER||9007199254740991;var INTERVALS={millisecond:{major:true,size:1,steps:[1,2,5,10,20,50,100,250,500]},second:{major:true,size:1e3,steps:[1,2,5,10,30]},minute:{major:true,size:6e4,steps:[1,2,5,10,30]},hour:{major:true,size:36e5,steps:[1,2,3,6,12]},day:{major:true,size:864e5,steps:[1,2,5]},week:{major:false,size:6048e5,steps:[1,2,3,4]},month:{major:true,size:2628e6,steps:[1,2,3]},quarter:{major:false,size:7884e6,steps:[1,2,3,4]},year:{major:true,size:3154e7}};var UNITS=Object.keys(INTERVALS);function sorter(a,b){return a-b}function arrayUnique(items){var hash={};var out=[];var i,ilen,item;for(i=0,ilen=items.length;i<ilen;++i){item=items[i];if(!hash[item]){hash[item]=true;out.push(item)}}return out}function buildLookupTable(timestamps,min,max,distribution){if(distribution==="linear"||!timestamps.length){return[{time:min,pos:0},{time:max,pos:1}]}var table=[];var items=[min];var i,ilen,prev,curr,next;for(i=0,ilen=timestamps.length;i<ilen;++i){curr=timestamps[i];if(curr>min&&curr<max){items.push(curr)}}items.push(max);for(i=0,ilen=items.length;i<ilen;++i){next=items[i+1];prev=items[i-1];curr=items[i];if(prev===undefined||next===undefined||Math.round((next+prev)/2)!==curr){table.push({time:curr,pos:i/(ilen-1)})}}return table}function lookup(table,key,value){var lo=0;var hi=table.length-1;var mid,i0,i1;while(lo>=0&&lo<=hi){mid=lo+hi>>1;i0=table[mid-1]||null;i1=table[mid];if(!i0){return{lo:null,hi:i1}}else if(i1[key]<value){lo=mid+1}else if(i0[key]>value){hi=mid-1}else{return{lo:i0,hi:i1}}}return{lo:i1,hi:null}}function interpolate(table,skey,sval,tkey){var range=lookup(table,skey,sval);var prev=!range.lo?table[0]:!range.hi?table[table.length-2]:range.lo;var next=!range.lo?table[1]:!range.hi?table[table.length-1]:range.hi;var span=next[skey]-prev[skey];var ratio=span?(sval-prev[skey])/span:0;var offset=(next[tkey]-prev[tkey])*ratio;return prev[tkey]+offset}function momentify(value,options){var parser=options.parser;var format=options.parser||options.format;if(typeof parser==="function"){return parser(value)}if(typeof value==="string"&&typeof format==="string"){return moment(value,format)}if(!(value instanceof moment)){value=moment(value)}if(value.isValid()){return value}if(typeof format==="function"){return format(value)}return value}function parse(input,scale){if(helpers.isNullOrUndef(input)){return null}var options=scale.options.time;var value=momentify(scale.getRightValue(input),options);if(!value.isValid()){return null}if(options.round){value.startOf(options.round)}return value.valueOf()}function determineStepSize(min,max,unit,capacity){var range=max-min;var interval=INTERVALS[unit];var milliseconds=interval.size;var steps=interval.steps;var i,ilen,factor;if(!steps){return Math.ceil(range/((capacity||1)*milliseconds))}for(i=0,ilen=steps.length;i<ilen;++i){factor=steps[i];if(Math.ceil(range/(milliseconds*factor))<=capacity){break}}return factor}function determineUnit(minUnit,min,max,capacity){var ilen=UNITS.length;var i,interval,factor;for(i=UNITS.indexOf(minUnit);i<ilen-1;++i){interval=INTERVALS[UNITS[i]];factor=interval.steps?interval.steps[interval.steps.length-1]:MAX_INTEGER;if(Math.ceil((max-min)/(factor*interval.size))<=capacity){return UNITS[i]}}return UNITS[ilen-1]}function determineMajorUnit(unit){for(var i=UNITS.indexOf(unit)+1,ilen=UNITS.length;i<ilen;++i){if(INTERVALS[UNITS[i]].major){return UNITS[i]}}}function generate(min,max,minor,major,capacity,options){var timeOpts=options.time;var stepSize=helpers.valueOrDefault(timeOpts.stepSize,timeOpts.unitStepSize);var weekday=minor==="week"?timeOpts.isoWeekday:false;var majorTicksEnabled=options.ticks.major.enabled;var interval=INTERVALS[minor];var first=moment(min);var last=moment(max);var ticks=[];var time;if(!stepSize){stepSize=determineStepSize(min,max,minor,capacity)}if(weekday){first=first.isoWeekday(weekday);last=last.isoWeekday(weekday)}first=first.startOf(weekday?"day":minor);last=last.startOf(weekday?"day":minor);if(last<max){last.add(1,minor)}time=moment(first);if(majorTicksEnabled&&major&&!weekday&&!timeOpts.round){time.startOf(major);time.add(~~((first-time)/(interval.size*stepSize))*stepSize,minor)}for(;time<last;time.add(stepSize,minor)){ticks.push(+time)}ticks.push(+time);return ticks}function computeOffsets(table,ticks,min,max,options){var left=0;var right=0;var upper,lower;if(options.offset&&ticks.length){if(!options.time.min){upper=ticks.length>1?ticks[1]:max;lower=ticks[0];left=(interpolate(table,"time",upper,"pos")-interpolate(table,"time",lower,"pos"))/2}if(!options.time.max){upper=ticks[ticks.length-1];lower=ticks.length>1?ticks[ticks.length-2]:min;right=(interpolate(table,"time",upper,"pos")-interpolate(table,"time",lower,"pos"))/2}}return{left:left,right:right}}function ticksFromTimestamps(values,majorUnit){var ticks=[];var i,ilen,value,major;for(i=0,ilen=values.length;i<ilen;++i){value=values[i];major=majorUnit?value===+moment(value).startOf(majorUnit):false;ticks.push({value:value,major:major})}return ticks}module.exports=function(Chart){var defaultConfig={position:"bottom",distribution:"linear",bounds:"data",time:{parser:false,format:false,unit:false,round:false,displayFormat:false,isoWeekday:false,minUnit:"millisecond",displayFormats:{millisecond:"h:mm:ss.SSS a",second:"h:mm:ss a",minute:"h:mm a",hour:"hA",day:"MMM D",week:"ll",month:"MMM YYYY",quarter:"[Q]Q - YYYY",year:"YYYY"}},ticks:{autoSkip:false,source:"auto",major:{enabled:false}}};var TimeScale=Chart.Scale.extend({initialize:function(){if(!moment){throw new Error("Chart.js - Moment.js could not be found! You must include it before Chart.js to use the time scale. Download at https://momentjs.com")}this.mergeTicksOptions();Chart.Scale.prototype.initialize.call(this)},update:function(){var me=this;var options=me.options;if(options.time&&options.time.format){console.warn("options.time.format is deprecated and replaced by options.time.parser.")}return Chart.Scale.prototype.update.apply(me,arguments)},getRightValue:function(rawValue){if(rawValue&&rawValue.t!==undefined){rawValue=rawValue.t}return Chart.Scale.prototype.getRightValue.call(this,rawValue)},determineDataLimits:function(){var me=this;var chart=me.chart;var timeOpts=me.options.time;var min=parse(timeOpts.min,me)||MAX_INTEGER;var max=parse(timeOpts.max,me)||MIN_INTEGER;var timestamps=[];var datasets=[];var labels=[];var i,j,ilen,jlen,data,timestamp;for(i=0,ilen=chart.data.labels.length;i<ilen;++i){labels.push(parse(chart.data.labels[i],me))}for(i=0,ilen=(chart.data.datasets||[]).length;i<ilen;++i){if(chart.isDatasetVisible(i)){data=chart.data.datasets[i].data;if(helpers.isObject(data[0])){datasets[i]=[];for(j=0,jlen=data.length;j<jlen;++j){timestamp=parse(data[j],me);timestamps.push(timestamp);datasets[i][j]=timestamp}}else{timestamps.push.apply(timestamps,labels);datasets[i]=labels.slice(0)}}else{datasets[i]=[]}}if(labels.length){labels=arrayUnique(labels).sort(sorter);min=Math.min(min,labels[0]);max=Math.max(max,labels[labels.length-1])}if(timestamps.length){timestamps=arrayUnique(timestamps).sort(sorter);min=Math.min(min,timestamps[0]);max=Math.max(max,timestamps[timestamps.length-1])}min=min===MAX_INTEGER?+moment().startOf("day"):min;max=max===MIN_INTEGER?+moment().endOf("day")+1:max;me.min=Math.min(min,max);me.max=Math.max(min+1,max);me._horizontal=me.isHorizontal();me._table=[];me._timestamps={data:timestamps,datasets:datasets,labels:labels}},buildTicks:function(){var me=this;var min=me.min;var max=me.max;var options=me.options;var timeOpts=options.time;var formats=timeOpts.displayFormats;var capacity=me.getLabelCapacity(min);var unit=timeOpts.unit||determineUnit(timeOpts.minUnit,min,max,capacity);var majorUnit=determineMajorUnit(unit);var timestamps=[];var ticks=[];var i,ilen,timestamp;switch(options.ticks.source){case"data":timestamps=me._timestamps.data;break;case"labels":timestamps=me._timestamps.labels;break;case"auto":default:timestamps=generate(min,max,unit,majorUnit,capacity,options)}if(options.bounds==="ticks"&&timestamps.length){min=timestamps[0];max=timestamps[timestamps.length-1]}min=parse(timeOpts.min,me)||min;max=parse(timeOpts.max,me)||max;for(i=0,ilen=timestamps.length;i<ilen;++i){timestamp=timestamps[i];if(timestamp>=min&&timestamp<=max){ticks.push(timestamp)}}me.min=min;me.max=max;me._unit=unit;me._majorUnit=majorUnit;me._minorFormat=formats[unit];me._majorFormat=formats[majorUnit];me._table=buildLookupTable(me._timestamps.data,min,max,options.distribution);me._offsets=computeOffsets(me._table,ticks,min,max,options);return ticksFromTimestamps(ticks,majorUnit)},getLabelForIndex:function(index,datasetIndex){var me=this;var data=me.chart.data;var timeOpts=me.options.time;var label=data.labels&&index<data.labels.length?data.labels[index]:"";var value=data.datasets[datasetIndex].data[index];if(helpers.isObject(value)){label=me.getRightValue(value)}if(timeOpts.tooltipFormat){label=momentify(label,timeOpts).format(timeOpts.tooltipFormat)}return label},tickFormatFunction:function(tick,index,ticks){var me=this;var options=me.options;var time=tick.valueOf();var majorUnit=me._majorUnit;var majorFormat=me._majorFormat;var majorTime=tick.clone().startOf(me._majorUnit).valueOf();var majorTickOpts=options.ticks.major;var major=majorTickOpts.enabled&&majorUnit&&majorFormat&&time===majorTime;var label=tick.format(major?majorFormat:me._minorFormat);var tickOpts=major?majorTickOpts:options.ticks.minor;var formatter=helpers.valueOrDefault(tickOpts.callback,tickOpts.userCallback);return formatter?formatter(label,index,ticks):label},convertTicksToLabels:function(ticks){var labels=[];var i,ilen;for(i=0,ilen=ticks.length;i<ilen;++i){labels.push(this.tickFormatFunction(moment(ticks[i].value),i,ticks))}return labels},getPixelForOffset:function(time){var me=this;var size=me._horizontal?me.width:me.height;var start=me._horizontal?me.left:me.top;var pos=interpolate(me._table,"time",time,"pos");return start+size*(me._offsets.left+pos)/(me._offsets.left+1+me._offsets.right)},getPixelForValue:function(value,index,datasetIndex){var me=this;var time=null;if(index!==undefined&&datasetIndex!==undefined){time=me._timestamps.datasets[datasetIndex][index]}if(time===null){time=parse(value,me)}if(time!==null){return me.getPixelForOffset(time)}},getPixelForTick:function(index){var ticks=this.getTicks();return index>=0&&index<ticks.length?this.getPixelForOffset(ticks[index].value):null},getValueForPixel:function(pixel){var me=this;var size=me._horizontal?me.width:me.height;var start=me._horizontal?me.left:me.top;var pos=(size?(pixel-start)/size:0)*(me._offsets.left+1+me._offsets.left)-me._offsets.right;var time=interpolate(me._table,"pos",pos,"time");return moment(time)},getLabelWidth:function(label){var me=this;var ticksOpts=me.options.ticks;var tickLabelWidth=me.ctx.measureText(label).width;var angle=helpers.toRadians(ticksOpts.maxRotation);var cosRotation=Math.cos(angle);var sinRotation=Math.sin(angle);var tickFontSize=helpers.valueOrDefault(ticksOpts.fontSize,defaults.global.defaultFontSize);return tickLabelWidth*cosRotation+tickFontSize*sinRotation},getLabelCapacity:function(exampleTime){var me=this;me._minorFormat=me.options.time.displayFormats.millisecond;var exampleLabel=me.tickFormatFunction(moment(exampleTime),0,[]);var tickLabelWidth=me.getLabelWidth(exampleLabel);var innerWidth=me.isHorizontal()?me.width:me.height;return Math.floor(innerWidth/tickLabelWidth)}});Chart.scaleService.registerScaleType("time",TimeScale,defaultConfig)};